from typing import Protocol, TypeVar

T = TypeVar("T")


class Queue(Protocol[T]):
    def __init__(self, *args, **kwargs): ...
    def qsize(self) -> int: ...
    def empty(self) -> bool: ...
    def full(self) -> bool: ...
    def put(self, item: T, block=True, timeout=None) -> None: ...
    def get(self, block=True, timeout=None) -> T: ...
    def put_nowait(self, item: T) -> None: ...
    def get_nowait(self) -> T: ...
